> For the complete documentation index, see [llms.txt](https://docs.exploratory.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.exploratory.io/data-wrangling.md).

# Data Wrangling

- [Command Line mode for faster and more flexible data interaction in Exploratory](https://docs.exploratory.io/data-wrangling/command-mode.md)
- [Select / Remove Columns](https://docs.exploratory.io/data-wrangling/select.md)
- [Reorder Columns](https://docs.exploratory.io/data-wrangling/reorder.md)
- [Create New Calculation](https://docs.exploratory.io/data-wrangling/mutate.md)
- [Create New Calculation for Multiple Columns](https://docs.exploratory.io/data-wrangling/mutate_at.md)
- [Summarize (Aggregate)](https://docs.exploratory.io/data-wrangling/summarize.md)
- [Group](https://docs.exploratory.io/data-wrangling/group.md)
- [Filter](https://docs.exploratory.io/data-wrangling/filter.md)
- [Rename](https://docs.exploratory.io/data-wrangling/rename.md)
- [Arrange (Sort)](https://docs.exploratory.io/data-wrangling/arrange.md)
- [Top / Bottom N](https://docs.exploratory.io/data-wrangling/top_n.md)
- [Join](https://docs.exploratory.io/data-wrangling/join.md)
- [Merge](https://docs.exploratory.io/data-wrangling/merge.md)
- [Gather](https://docs.exploratory.io/data-wrangling/gather.md)
- [Spread](https://docs.exploratory.io/data-wrangling/spread.md)
- [Pivot](https://docs.exploratory.io/data-wrangling/pivot.md)
- [Expand](https://docs.exploratory.io/data-wrangling/expand.md)
- [Complete](https://docs.exploratory.io/data-wrangling/complete.md)
- [Separate](https://docs.exploratory.io/data-wrangling/separate.md)
- [Unite](https://docs.exploratory.io/data-wrangling/unite.md)
- [Bind Rows](https://docs.exploratory.io/data-wrangling/bind_rows.md)
- [Bind Columns](https://docs.exploratory.io/data-wrangling/bind_columns.md)
- [Keep Only Unique Rows](https://docs.exploratory.io/data-wrangling/distinct.md)
- [Keep Only Duplicated Rows](https://docs.exploratory.io/data-wrangling/get_dupes.md)
- [Slice](https://docs.exploratory.io/data-wrangling/slice.md)
- [Drop NA](https://docs.exploratory.io/data-wrangling/drop_na.md)
- [Sample](https://docs.exploratory.io/data-wrangling/sample.md)
- [Impute NA](https://docs.exploratory.io/data-wrangling/impute_na.md)
- [Fill](https://docs.exploratory.io/data-wrangling/fill.md)
- [Create Buckets](https://docs.exploratory.io/data-wrangling/buckets.md)
- [Assign New Values to Existing Values - Recode](https://docs.exploratory.io/data-wrangling/recode.md)
- [Assign New Values by Setting Conditions - Case When](https://docs.exploratory.io/data-wrangling/case_when.md)
- [Work with Categories](https://docs.exploratory.io/data-wrangling/categories.md)
- [Data Type Conversion](https://docs.exploratory.io/data-wrangling/type-convert.md)
- [Row as header](https://docs.exploratory.io/data-wrangling/row_as_header.md)
- [Ungroup](https://docs.exploratory.io/data-wrangling/ungroup.md)
- [Unnest](https://docs.exploratory.io/data-wrangling/unnest.md)
- [Separate List Items into Columns (Unnest Wider)](https://docs.exploratory.io/data-wrangling/unnest_wider.md)
- [Separate List Items into Rows (Unnest Longer)](https://docs.exploratory.io/data-wrangling/unnest_longer.md)
- [Separate Address (Japan)](https://docs.exploratory.io/data-wrangling/separate-japanese-address.md)
- [Hoist](https://docs.exploratory.io/data-wrangling/hoist.md)
- [Remove Empty Rows](https://docs.exploratory.io/data-wrangling/remove_empty_rows.md)
- [Remove Empty Columns](https://docs.exploratory.io/data-wrangling/remove_empty_cols.md)
- [Clean Column Names](https://docs.exploratory.io/data-wrangling/clean_names.md)
- [Window Calculation](https://docs.exploratory.io/data-wrangling/window-calculation.md)
- [Window Calculation (日本語)](https://docs.exploratory.io/data-wrangling/window-calculation_ja.md)
- [Add Row](https://docs.exploratory.io/data-wrangling/add_row.md)
- [Text Wrangling](https://docs.exploratory.io/data-wrangling/text_wrangling.md)
- [Regular Expression Cheat Sheet](https://docs.exploratory.io/data-wrangling/regular_expression.md)
- [Regular Expression Cheat Sheet (日本語)](https://docs.exploratory.io/data-wrangling/regular_expression_ja.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.exploratory.io/data-wrangling.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
